<?php
/**
* @version      2.4.1 21.10.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
jimport( 'joomla.application.component.model');

class JshoppingModelProducts extends JModel{
    
    function getAllProducts($category_id, $product_id = null, $limitstart = null, $limit = null, $text_search = null, $result = "list") {
            
        $lang = &JSFactory::getLang();
        $db =& JFactory::getDBO(); 
        $where = ($product_id)?("AND pr.product_id <> '" . $db->getEscaped($product_id) . "' "):('');
        if($limit > 0) {
            $limit = " LIMIT " . $limitstart . " , " . $limit;
        }else{
            $limit = "";
        }
        $where .= ($text_search) ? ( " AND CONCAT_WS('|',pr.`".$lang->get('name')."`,pr.`".$lang->get('short_description')."`,pr.`".$lang->get('description')."` ) LIKE '%" . $text_search . "%' " ) : ('');

        if($category_id) {
            $query = "SELECT pr.product_id, pr.product_publish, pr_cat.product_ordering, pr.`".$lang->get('name')."` as name, pr.`".$lang->get('short_description')."` as short_description, pr.product_ean as ean, pr.product_quantity as qty, pr.product_thumb_image as image, pr.product_price FROM `#__jshopping_products` AS pr
                      LEFT JOIN `#__jshopping_products_to_categories` AS pr_cat USING (product_id)
                      WHERE pr_cat.category_id = '" . $db->getEscaped($category_id) . "' ".$where."
                      ORDER BY pr_cat.product_ordering ASC ".$limit;
        } else {
            $query = "SELECT pr.product_id, pr.product_publish, pr.`".$lang->get('name')."` as name, pr.`".$lang->get('short_description')."` as short_description, pr.product_ean as ean, pr.product_quantity as qty, pr.product_thumb_image as image, pr.product_price FROM `#__jshopping_products` AS pr 
                      WHERE 1 ".$where." ORDER BY pr.product_id ".$limit;
        }
        $db->setQuery($query);
        if ($result=="list"){
            return $db->loadObjectList();
        }else{
            $db->query();
            return $db->getNumRows();    
        }
    }
    
    function getCountAllProducts($category_id, $text_search=null) {
        return $this->getAllProducts($category_id, null, null, null, $text_search, "count");
    }
    
    function productInCategory($product_id, $category_id) {
        $db =& JFactory::getDBO();
        $query = "SELECT prod_cat.category_id FROM `#__jshopping_products_to_categories` AS prod_cat
                   WHERE prod_cat.product_id = '".$db->getEscaped($product_id)."' AND prod_cat.category_id = '".$db->getEscaped($category_id)."'";
        $db->setQuery($query);
        $res = $db->query();
        return $db->getNumRows($res);
    }
    
    function getMaxOrderingInCategory($category_id) {
        $db =& JFactory::getDBO();
        $query = "SELECT MAX(product_ordering) as k FROM `#__jshopping_products_to_categories` WHERE category_id = '".$db->getEscaped($category_id)."'";
        $db->setQuery($query);
        return $db->loadResult();
    }
    
    function setCategoryToProduct($product_id, $categories = array()){
        $db =& JFactory::getDBO();
        foreach ($categories as $cat_id) {
            if(!$this->productInCategory($product_id, $cat_id)){
                $ordering = $this->getMaxOrderingInCategory($cat_id)+1;
                $query = "INSERT INTO `#__jshopping_products_to_categories`
                      SET `product_id` = '".$db->getEscaped($product_id)."', `category_id` = '".$db->getEscaped($cat_id)."', `product_ordering` = '".$db->getEscaped($ordering)."'";
                $db->setQuery($query);
                $db->query();
            }
        }

        //delete other cat for product        
        $query = "select `category_id` from `#__jshopping_products_to_categories` where `product_id` = '".$db->getEscaped($product_id)."'";
        $db->setQuery($query);
        $listcat = $db->loadObjectList();
        foreach($listcat as $val){
            if (!in_array($val->category_id, $categories)){
                $query = "delete from `#__jshopping_products_to_categories` where `product_id` = '".$db->getEscaped($product_id)."' and `category_id` = '".$db->getEscaped($val->category_id)."'";
                $db->setQuery($query);
                $db->query();
            }
        }
                    
    }
    
    function getRelatedProducts($product_id){
        $db =& JFactory::getDBO();
        $query = "SELECT relation.product_related_id AS product_id, prod.product_is_add_price
                FROM `#__jshopping_products_relations` AS relation
                LEFT JOIN `#__jshopping_products` AS prod USING (product_id)
                WHERE prod.product_id = '".$db->getEscaped($product_id)."' AND prod.product_publish = '1' AND relation.product_id = prod.product_id";
        $db->setQuery($query);
        return $db->loadObjectList();
    }
    
    function saveAditionalPrice($product_id, $product_add_discount, $quantity_start, $quantity_finish){
        $db =& JFactory::getDBO();
        $query = "DELETE FROM `#__jshopping_products_prices` WHERE `product_id` = '".$db->getEscaped($product_id)."'";
        $db->setQuery($query);
        $db->query();
        
        $counter = 0;
        if (count($product_add_discount)){
            foreach ($product_add_discount as $key=>$value){
                
                if ((!$quantity_start[$key] && !$quantity_finish[$key])) continue;
                
                $query = "INSERT INTO `#__jshopping_products_prices` SET 
                            `product_id` = '" . $db->getEscaped($product_id) . "',
                            `discount` = '" . $db->getEscaped(saveAsPrice($product_add_discount[$key])) . "',
                            `product_quantity_start` = '" . intval($quantity_start[$key]) . "',
                            `product_quantity_finish` = '" . intval($quantity_finish[$key]) . "'";
                $db->setQuery($query);
                $db->query();
                $counter++;
            }
        }
        $product =& JTable::getInstance('product', 'jshop');
        $product->load($product_id);
        $product->product_is_add_price = ($counter>0) ? (1) : (0);
        $product->store();
    }
    
    
}
?>